package com.virtual.plat.server.rainbow;

import com.extjs.gxt.ui.client.data.BaseModelData;
import com.extjs.gxt.ui.client.data.ModelData;
import com.virtual.common.AppException;
import com.virtual.common.FuncUtil;
import com.virtual.common.StringManager;
import com.virtual.plat.client.operator.LoginInfo;
import com.virtual.plat.server.LocalUser;
import com.virtual.plat.server.RequestData;
import com.virtual.plat.server.ServerUtils;
import com.virtual.plat.server.controller.entity.VmUserPo;
import com.virtual.plat.server.entity.Domain;
import com.virtual.plat.server.entity.Host;
import com.virtual.plat.server.entity.PublicCloud;
import com.virtual.plat.server.host.HostMgr;
import com.virtual.plat.server.http.pool.HttpConnectionManager;
import com.virtual.plat.server.message.MessageMgr;
import com.virtual.plat.server.operlog.OperationLogMgr;
import com.virtual.plat.server.organize.OrganizationHandler;
import com.virtual.plat.server.publiccloud.PublicCloudDao;
import com.virtual.plat.server.rainbow.MigrateEntity;
import com.virtual.plat.server.rainbow.Rainbow;
import com.virtual.plat.server.rainbow.client.InnerRainbowClient;
import com.virtual.plat.server.rs.message.entity.RsTaskMsg;
import com.virtual.plat.server.rs.vm.entity.RsDomain;
import com.virtual.plat.server.virtualhost.DomainMgr;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import javax.annotation.Resource;
import javax.transaction.Transactional;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Service;

@Service("rainbowMgr")
public class RainbowMgr implements Rainbow {

   private static Log a = LogFactory.getLog(RainbowMgr.class);
   @Resource
   private HttpConnectionManager b = null;
   @Resource
   private PublicCloudDao c;
   @Resource
   protected MessageMgr messageMgr = null;
   private static StringManager d = StringManager.getManager(RainbowMgr.class);
   private static StringManager e = StringManager.getManager(MessageMgr.class);
   @Resource
   private OperationLogMgr f = null;
   @Resource
   private OrganizationHandler g = null;
   @Resource
   private HostMgr h;
   @Resource
   private DomainMgr i;


   @Transactional
   public void checkVmCanMigrate(long var1, long var3, long var5, long var7) {
      PublicCloud var9 = this.c.readById(Long.valueOf(var5));
      PublicCloud var21 = this.c.readById(Long.valueOf(var1));

      try {
         InnerRainbowClient var22 = new InnerRainbowClient(var21, this.b);
         Throwable var2 = null;
         boolean var15 = false;

         try {
            var15 = true;
            var22.checkVmCanMigrate(var3, var9, var7);
            var15 = false;
         } catch (Throwable var17) {
            var2 = var17;
            throw var17;
         } finally {
            if(var15) {
               if(var2 != null) {
                  try {
                     var22.close();
                  } catch (Throwable var16) {
                     var2.addSuppressed(var16);
                  }
               } else {
                  var22.close();
               }

            }
         }

         var22.close();
      } catch (AppException var19) {
         a.error(String.format("Can\'t migrate domain(%d) to publicCloud(%d)", new Object[]{Long.valueOf(var3), Long.valueOf(var5)}), var19);
         throw var19;
      } catch (Exception var20) {
         a.error(String.format("Can\'t migrate domain(%d) to publicCloud(%d)", new Object[]{Long.valueOf(var3), Long.valueOf(var5)}), var20);
         throw new AppException(20655);
      }
   }

   @Transactional
   public void migrate(long var1, long var3, MigrateEntity var5) {
      PublicCloud var6 = this.c.readById(Long.valueOf(var3));
      PublicCloud var7 = this.c.readById(Long.valueOf(var1));

      try {
         InnerRainbowClient var43 = new InnerRainbowClient(var7, this.b);
         Throwable var8 = null;
         boolean var37 = false;

         try {
            var37 = true;
            long var10 = var43.addMigrateTask(var6, var5);
            LoginInfo var10004 = LocalUser.get();
            long var20 = var10;
            LoginInfo var9 = var10004;
            PublicCloud var44 = this.c.readById(Long.valueOf(var1));
            String var11 = d.getString("rainbow");
            String var12 = d.getString("rainbow.desc", new Object[]{var44.getName(), var5.getDomainTitle(), var6.getName()});
            RequestData var45 = new RequestData(901, (ModelData)null, var9.getLoginName(), var9.getUserName(), var9.getLoginIp(), var11, var44.getName(), Long.valueOf(var1), String.format(var12, new Object[]{""}));
            long var26 = this.messageMgr.addMessage(var45.getOperateTitle(), var45.getOperateTarget(), 0, var45.getOperateDesc(), var45.getLoginName(), var45.getIpAddress(), new Date(), (Date)null, (List)null, var45.getRequestType(), var45.getTargetId());
            var45.setMessageId(var26);
            this.messageMgr.updateMessage(var26, new Date());
            ArrayList var46 = new ArrayList();
            BaseModelData var13;
            (var13 = new BaseModelData()).set("srcCvm", Long.valueOf(var1));
            long var30 = var6.getId().longValue();
            var13.set("dstCvm", Long.valueOf(var30));
            var46.add(var13);
            this.messageMgr.updateMessage(var26, var46);
            (new Thread() {

               // $FF: synthetic field
               private PublicCloud a;
               // $FF: synthetic field
               private long b;
               // $FF: synthetic field
               private long c;
               // $FF: synthetic field
               private String d;
               // $FF: synthetic field
               private MigrateEntity e;
               // $FF: synthetic field
               private LoginInfo f;
               // $FF: synthetic field
               private PublicCloud g;
               // $FF: synthetic field
               private RainbowMgr h = RainbowMgr.this;

               {
                  this.a = var2;
                  this.b = var3;
                  this.c = var5;
                  this.d = var7;
                  this.e = var8;
                  this.f = var9;
                  this.g = var10;
               }
               public final void run() {
                  try {
                     int var8;
                     while((var8 = RainbowMgr.a(this.h, this.a, this.b)) != 100) {
                        this.h.messageMgr.updateMessage(this.c, var8, String.format(this.d, new Object[]{""}));

                        try {
                           Thread.sleep(3000L);
                        } catch (InterruptedException var5) {
                           ;
                        }
                     }

                     Iterator var3 = this.h.g.queryUserVmByVmId(Integer.valueOf(0), Integer.valueOf(0), Integer.valueOf(1), "id", Long.valueOf(this.e.getCicId()), (String)null, (Integer)null, (Long)null).iterator();

                     while(var3.hasNext()) {
                        ModelData var4 = (ModelData)var3.next();
                        VmUserPo var9 = this.h.convertModelData2UserVm(var4, this.e);
                        this.h.g.revokeDomain(var9, this.f);
                     }

                     long var11 = this.e.getDestHostId();

                     try {
                        Host var10 = this.h.h.queryHostByUniqueKeyAndCloudId(String.valueOf(var11), this.g.getId().longValue());
                        Domain var2;
                        (var2 = this.h.i.queryDomainById(Long.valueOf(this.e.getCicId()))).setHostId(var10.getId());
                        var2.setHostPoolId(var10.getHostpoolId());
                        var2.setClusterId(var10.getClusterId());
                        var2.setPublicCloudId(var10.getPublicCloudId());
                        var2.setUniqueKey(this.h.a(this.g, var2.getDomainName()));
                        this.h.i.updateDomain(var2);
                     } catch (Exception var6) {
                        RainbowMgr.a.error("Modify domain info after rainbow migrate failed.", var6);
                     }

                     this.h.messageMgr.updateMessage(this.c, 100, String.format(this.d, new Object[]{RainbowMgr.e.getString("success")}), Integer.valueOf(0));
                     this.h.f.addSuccessLog(this.f, 132, String.format(this.d, new Object[]{RainbowMgr.e.getString("success")}), Long.valueOf(this.b));
                  } catch (AppException var7) {
                     RainbowMgr.a.error("Sync task failed.", var7);
                     String var1 = var7.getErrorMessage();
                     this.h.messageMgr.updateMessage(this.c, 100, String.format(this.d, new Object[]{RainbowMgr.e.getString("fail")}) + RainbowMgr.e.getString("fail.cause") + var1, Integer.valueOf(1));
                     this.h.f.addFailureLog(this.f, 132, String.format(this.d, new Object[]{RainbowMgr.e.getString("fail")}), var1, Long.valueOf(this.b));
                  }
               }
            }).start();
            var37 = false;
         } catch (Throwable var39) {
            var8 = var39;
            throw var39;
         } finally {
            if(var37) {
               if(var8 != null) {
                  try {
                     var43.close();
                  } catch (Throwable var38) {
                     var8.addSuppressed(var38);
                  }
               } else {
                  var43.close();
               }

            }
         }

         var43.close();
      } catch (AppException var41) {
         a.error(String.format("Failed to migrate domain(%d) to publicCloud(%d)", new Object[]{Long.valueOf(var5.getDomainId()), Long.valueOf(var3)}), var41);
         throw var41;
      } catch (Exception var42) {
         a.error(String.format("Failed to migrate domain(%d) to publicCloud(%d)", new Object[]{Long.valueOf(var5.getDomainId()), Long.valueOf(var3)}), var42);
         throw new AppException(20655, var42);
      }
   }

   private void a(long var1, PublicCloud var3, MigrateEntity var4, LoginInfo var5, long var6) {
      PublicCloud var8 = this.c.readById(Long.valueOf(var1));
      String var9 = d.getString("rainbow");
      String var10 = d.getString("rainbow.desc", new Object[]{var8.getName(), var4.getDomainTitle(), var3.getName()});
      RequestData var18 = new RequestData(901, (ModelData)null, var5.getLoginName(), var5.getUserName(), var5.getLoginIp(), var9, var8.getName(), Long.valueOf(var1), String.format(var10, new Object[]{""}));
      long var12 = this.messageMgr.addMessage(var18.getOperateTitle(), var18.getOperateTarget(), 0, var18.getOperateDesc(), var18.getLoginName(), var18.getIpAddress(), new Date(), (Date)null, (List)null, var18.getRequestType(), var18.getTargetId());
      var18.setMessageId(var12);
      this.messageMgr.updateMessage(var12, new Date());
      ArrayList var19 = new ArrayList();
      BaseModelData var11;
      (var11 = new BaseModelData()).set("srcCvm", Long.valueOf(var1));
      long var16 = var3.getId().longValue();
      var11.set("dstCvm", Long.valueOf(var16));
      var19.add(var11);
      this.messageMgr.updateMessage(var12, var19);
      (new Thread() {

         // $FF: synthetic field
         private PublicCloud a;
         // $FF: synthetic field
         private long b;
         // $FF: synthetic field
         private long c;
         // $FF: synthetic field
         private String d;
         // $FF: synthetic field
         private MigrateEntity e;
         // $FF: synthetic field
         private LoginInfo f;
         // $FF: synthetic field
         private PublicCloud g;
         // $FF: synthetic field
         private RainbowMgr h = RainbowMgr.this;

         {
            this.a = var2;
            this.b = var3;
            this.c = var5;
            this.d = var7;
            this.e = var8;
            this.f = var9;
            this.g = var10;
         }
         public final void run() {
            try {
               int var8;
               while((var8 = RainbowMgr.a(this.h, this.a, this.b)) != 100) {
                  this.h.messageMgr.updateMessage(this.c, var8, String.format(this.d, new Object[]{""}));

                  try {
                     Thread.sleep(3000L);
                  } catch (InterruptedException var5) {
                     ;
                  }
               }

               Iterator var3 = this.h.g.queryUserVmByVmId(Integer.valueOf(0), Integer.valueOf(0), Integer.valueOf(1), "id", Long.valueOf(this.e.getCicId()), (String)null, (Integer)null, (Long)null).iterator();

               while(var3.hasNext()) {
                  ModelData var4 = (ModelData)var3.next();
                  VmUserPo var9 = this.h.convertModelData2UserVm(var4, this.e);
                  this.h.g.revokeDomain(var9, this.f);
               }

               long var11 = this.e.getDestHostId();

               try {
                  Host var10 = this.h.h.queryHostByUniqueKeyAndCloudId(String.valueOf(var11), this.g.getId().longValue());
                  Domain var2;
                  (var2 = this.h.i.queryDomainById(Long.valueOf(this.e.getCicId()))).setHostId(var10.getId());
                  var2.setHostPoolId(var10.getHostpoolId());
                  var2.setClusterId(var10.getClusterId());
                  var2.setPublicCloudId(var10.getPublicCloudId());
                  var2.setUniqueKey(this.h.a(this.g, var2.getDomainName()));
                  this.h.i.updateDomain(var2);
               } catch (Exception var6) {
                  RainbowMgr.a.error("Modify domain info after rainbow migrate failed.", var6);
               }

               this.h.messageMgr.updateMessage(this.c, 100, String.format(this.d, new Object[]{RainbowMgr.e.getString("success")}), Integer.valueOf(0));
               this.h.f.addSuccessLog(this.f, 132, String.format(this.d, new Object[]{RainbowMgr.e.getString("success")}), Long.valueOf(this.b));
            } catch (AppException var7) {
               RainbowMgr.a.error("Sync task failed.", var7);
               String var1 = var7.getErrorMessage();
               this.h.messageMgr.updateMessage(this.c, 100, String.format(this.d, new Object[]{RainbowMgr.e.getString("fail")}) + RainbowMgr.e.getString("fail.cause") + var1, Integer.valueOf(1));
               this.h.f.addFailureLog(this.f, 132, String.format(this.d, new Object[]{RainbowMgr.e.getString("fail")}), var1, Long.valueOf(this.b));
            }
         }
      }).start();
   }

   protected VmUserPo convertModelData2UserVm(ModelData var1, MigrateEntity var2) {
      VmUserPo var3;
      (var3 = new VmUserPo()).setId((Long)var1.get("id"));
      var3.setDesktopPoolId((Long)var1.get("desktopPoolId"));
      var3.setDomainId(Long.valueOf(var2.getCicId()));
      var3.setFlag((Integer)var1.get("flag"));
      var3.setName((String)var1.get("name"));
      var3.setOrgId((Long)var1.get("orgId"));
      var3.setTitle(var2.getDomainTitle());
      return var3;
   }

   private String a(PublicCloud var1, String var2) {
      DefaultHttpClient var3 = null;
      var2 = "/cas/casrs/vm/basicInfo/" + var2;
      HttpGet var18;
      (var18 = new HttpGet(var2.toString())).addHeader("accept", "application/xml");
      String var4 = var1.getProtocal();
      String var5 = var1.getUri();
      String var6 = var1.getUserName();
      String var7 = var1.getPassword();
      int var17 = var1.getPort().intValue();

      try {
         HttpResponse var19 = (var3 = this.b.getConnection(var4, var5, var17, var6, var7)).execute(var18);
         if(200 != var19.getStatusLine().getStatusCode() && 204 != var19.getStatusLine().getStatusCode()) {
            throw new AppException(ServerUtils.getErrorCode(var19));
         }

         String var8 = null;

         try {
            var8 = EntityUtils.toString(var19.getEntity(), "UTF-8");
         } catch (Exception var13) {
            a.error((Object)null, var13);
         }

         var7 = String.valueOf(((RsDomain)FuncUtil.convertXmlToObject(var8.trim(), RsDomain.class)).getId());
      } catch (AppException var14) {
         throw var14;
      } catch (Exception var15) {
         throw new AppException(11, var15);
      } finally {
         var18.abort();
         this.b.releaseConnection(var4, var5, var17, var6, var3);
      }

      return var7;
   }

   private int a(PublicCloud var1, long var2) {
      RsTaskMsg var4;
      if(!(var4 = this.b(var1, var2)).isCompleted()) {
         return var4.getProgress();
      } else if(var4.getResult().intValue() == 0) {
         return 100;
      } else {
         String var5 = StringUtils.substringAfterLast(var4.getDetail(), e.getString("fail.cause"));
         throw new AppException('\uecf4', var5);
      }
   }

   private RsTaskMsg b(PublicCloud var1, long var2) {
      DefaultHttpClient var4 = null;
      String var18 = "/cas/casrs/message/" + var2;
      HttpGet var19;
      (var19 = new HttpGet(var18.toString())).addHeader("accept", "application/xml");
      String var3 = var1.getProtocal();
      String var5 = var1.getUri();
      String var6 = var1.getUserName();
      String var7 = var1.getPassword();
      int var17 = var1.getPort().intValue();

      RsTaskMsg var21;
      try {
         HttpResponse var20 = (var4 = this.b.getConnection(var3, var5, var17, var6, var7)).execute(var19);
         if(200 != var20.getStatusLine().getStatusCode() && 204 != var20.getStatusLine().getStatusCode()) {
            throw new AppException(ServerUtils.getErrorCode(var20));
         }

         String var8 = null;

         try {
            var8 = EntityUtils.toString(var20.getEntity(), "UTF-8");
         } catch (Exception var13) {
            a.error((Object)null, var13);
         }

         var21 = (RsTaskMsg)FuncUtil.convertXmlToObject(var8.trim(), RsTaskMsg.class);
      } catch (AppException var14) {
         throw var14;
      } catch (Exception var15) {
         throw new AppException(11, var15);
      } finally {
         var19.abort();
         this.b.releaseConnection(var3, var5, var17, var6, var4);
      }

      return var21;
   }

   public void setManager(HttpConnectionManager var1) {
      this.b = var1;
   }

   public void setPublicCloudDao(PublicCloudDao var1) {
      this.c = var1;
   }

   public void setMessageMgr(MessageMgr var1) {
      this.messageMgr = var1;
   }

   public void setOperationLogMgr(OperationLogMgr var1) {
      this.f = var1;
   }

   public void setOrgHandler(OrganizationHandler var1) {
      this.g = var1;
   }

   public void setHostMgr(HostMgr var1) {
      this.h = var1;
   }

   public void setDomainMgr(DomainMgr var1) {
      this.i = var1;
   }

   // $FF: synthetic method
   static int a(RainbowMgr var0, PublicCloud var1, long var2) {
      RsTaskMsg var8;
      if(!(var8 = var0.b(var1, var2)).isCompleted()) {
         return var8.getProgress();
      } else if(var8.getResult().intValue() == 0) {
         return 100;
      } else {
         String var9 = StringUtils.substringAfterLast(var8.getDetail(), e.getString("fail.cause"));
         throw new AppException('\uecf4', var9);
      }
   }

}
